package com.flyfish.framework.file.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@Getter
@AllArgsConstructor
public enum MediaType {

    UNKNOWN(Collections.emptyList(), "未知媒体"),
    AUDIO(Arrays.asList("mp3", "wma", "amr"), "音频"),
    VIDEO(Arrays.asList("mp4", "avi", "wmv", "mkv", "rmvb", "flv", "3gp", "m3u", "m3u8"), "视频"),
    GRAPHICS(Arrays.asList("jpg", "jpeg", "bpm", "tiff", "png", "gif", "svg", "ico"), "图像"),
    ARCHIVE(Arrays.asList("zip", "gz"), "压缩文档");

    private final List<String> suffix;

    private final String name;

    public static MediaType accept(String filename) {
        String extend = StringUtils.substringAfterLast(filename, ".");
        return Arrays.stream(values()).filter(value -> value.suffix.contains(extend)).findFirst().orElse(UNKNOWN);
    }
}
